
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>block浅析与使用block导致循环强引用举例 / 憋错料</title>

    <meta name="description" content="block浅析与使用block导致循环强引用举例 定义语法 外部变量值截获 改变外部变量值 block变量作用域导致block体从栈复制到堆同时变量持有了block体中截获的变量 block变量作用域导致强引用 typedef void(^BlockType)(NSString *str);//声明一个void(^)(NSString *str)的block类型,类型名为BlockType-(void)viewDidLoad{ int i=[self getValuesFrom:^int(int i, int y) {//算法由自己定,值由别人">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">block浅析与使用block导致循环强引用举例</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<ol>
<li>定义语法</li>
<li>外部变量值截获</li>
<li>改变外部变量值</li>
<li>block变量作用域导致block体从栈复制到堆同时变量持有了block体中截获的变量</li>
<li>block变量作用域导致强引用</li>
</ol>
<p><strong>typedef void(^BlockType)(NSString *str);</strong>//声明一个void(^)(NSString *str)的block类型，类型名为BlockType<br />-(void)viewDidLoad<br />{</p>
<ul>
<li>int i=[self getValuesFrom:<strong>^int(int i, int y) {//算法由自己定，值由别人传入</strong></li>
<li><strong>        return i+y;</strong></li>
<li><strong>    }</strong>];//拿到经自己算法的结果</li>
<li>NSLog(@"i=%d",i);</li>
<li>__block int test=100;</li>
<li>NSLog(@"test is:%d",test);//100</li>
<li><strong>void(^block1)()=^{</strong></li>
<li><strong>        NSLog(@"block1截获的test is:%d",test);</strong></li>
<li><strong>        test=110;</strong></li>
<li><strong>    };</strong></li>
<li>NSLog(@"test is:%d",test);//100</li>
<li>test+=1;</li>
<li>NSLog(@"test is:%d",test);//101</li>
<li>void(^block2)()=^{</li>
<li>NSLog(@"block2截获的test is:%d",test);</li>
<li>test=120;</li>
<li>};</li>
<li>NSLog(@"test is:%d",test);//101</li>
<li>test+=1;</li>
<li>NSLog(@"test is:%d",test);//102</li>
<li><strong>block1();</strong>//执行了block1，输出test为102,把test的值改变为110</li>
<li>NSLog(@"test is:%d",test);//110</li>
<li>test+=1;</li>
<li>NSLog(@"test is:%d",test);//111</li>
<li>block2();//执行了block2，输出test为111，把test的值改变为120</li>
<li>NSLog(@"test is:%d",test);//120</li>
<li>test+=1;</li>
<li>NSLog(@"test is:%d",test);//121
<ul>
<li>/*</li>
<li>得出结论，block截获外部变量值不是看block体实现的时候截获的，而是在执行block的时候，会把执行时当前外部变量值截获，</li>
<li>所以不存在担心实现的时候外部变量是这个值，到执行block的时候外部变量值变成另外的，即使多个block用到了同一个外部变量值，因为无论多少个地方用到了，同一刻操作该变量的只能有一个地方，并且block是在执行时才截获该值。不过也应注意外部变量值的截获是在</li>
<li>执行时才截获这个原则。</li>
<li>block内对外部变量的赋值操作会影响外部变量的实际结果。</li>
<li>*/</li>
</ul>
</li>
<li>void(^testIsCanHoldSelf)()=^{</li>
<li>NSLog(@"self is %@",self);</li>
<li>};</li>
<li>testIsCanHoldSelf();
<ul>
<li>/*</li>
<li>不会引起强引用，因为testIsCanHoldSelf的作用域为viewDidLoad函数，</li>
<li>testIsCanHoldSelf变量被废弃时，testIsCanHoldSelf截获的self持有权也会被释放</li>
<li>若把testIsCanHoldSelf声明为类的strong成员变量，就会导致循环引用，因为</li>
<li>testIsCanHoldSelf为强引用变量的话，block体在赋值给testIsCanHoldSelf的时候，block体</li>
<li>从栈复制到堆，block体截获了self或者只截获了self中的成员变量，</li>
<li>testIsCanHoldSelf也持有self，</li>
<li>self又持有testIsCanHold成员变量.</li>
<li>如果想通过把testIsCanHoldSelf声明为__weak类型的话，那么block体在生成的时候赋值给</li>
<li>__weak 的testIsCanHoldSelf，没变量持有该block体，那么该block体马上又被释放了，</li>
<li>（可以把block体当为对象考虑）</li>
<li>解决该强引用的问题，让testIsCanHoldSelf变量不持有self即可，但是block需要用到self</li>
<li>所以可以让block体截获一个__weak的self</li>
<li>__weak ViewController *weakSelf=self;</li>
<li>testIsCanHoldSelf=^{</li>
<li>NSLog(@"self is %@",weakSelf);</li>
<li>};</li>
<li>testIsCanHoldSelf();</li>
<li>*/</li>
</ul>
</li>
</ul>
<p>}</p>
<p>-(NSString *)testBlock{</p>
<ul>
<li>NSString *(^myBlock)(NSString *str)= ^/*NSString **/(NSString *str){</li>
<li>return str;</li>
<li>};//内嵌方法</li>
<li>return myBlock(@"testValues");</li>
</ul>
<p>}</p>
<p>-(int)getValuesFrom:<strong>(int(^)(int i,int y))block</strong>{</p>
<ul>
<li>return block(1,2);//block体内调用block</li>
</ul>
<p>}</p>
<p>循环强引用举例以及解决方案：</p>
<ul>
<li>EOCNetworkFetcher持有completion对象NSData对象，NSURL对象</li>
<li>EOCClass持有EOCNetworkFetcher对象，NSdata对象，</li>
<li>生成completion栈对象捕获EOCClass中的NSData对象</li>
<li>也就是间接捕获了self，</li>
<li>completion栈对象传入EOCNetworkFetcher对象被它的completion对象持有</li>
<li>EOCNetworkFetcher会把EOCClass的completion栈对象copy到堆中</li>
<li>从而EOCNetworkFetcher对象因持有completion堆对象而持有EOCClass对象</li>
<li>从而发生循环强引用。</li>
</ul>
<p>解决办法有两种：</p>
<ul>
<li>1.如果EOCClass中的EOCNetworkFetcher对象的持有者只是它本身，</p>
<ul>
<li>那么释放持有EOCNetworkFetcher对象，EOCNetworkFetcher对象没有了持有者，</li>
<li>之后就会释放内存，从而也会释放EOCNetworkFetcher对象里面的成员变量，从而</li>
<li>EOCNetworkFetcher对象里面的completion对象不持有EOCClass中的completion，从而</li>
<li>completion对象没有持有者便释放内存从而也会释放所捕获的EOCClass对象</li>
<li>从而循环强引用被打破了。</li>
</ul>
</li>
<li>2.如果EOCClass传入到EOCNetworkFetcher对象中的completion对象只有EOCNetworkFetcher持有，
<ul>
<li>那么让EOCNetworkFetcher对象不再持有传入的completion，从而不再持有completion捕获的EOCClass对象</li>
<li>从而循环强引用被打破了，也就是在适当的地方把EOCNetworkFetcher对象中的completion对象释放置为nil即可</li>
<li>一般采用第二种，让提供API方来处理强引用问题而不是使用API方来处理</li>
</ul>
</li>
</ul>
<ul>
<li>如果把EOCClass中的completion捕获的对象为__weak变量呢？</p>
<ul>
<li>如果该__weak变量是在方法体中声明，那么EOCClass中的方法体执行完，__weak变量作用域超过了就释放对象</li>
<li>所以EOCNetworkFetcher对象无法赋值EOCClass对象。</li>
<li>如果该__weak变量是EOCClass对象的成员变量，那么传入到EOCNetworkFetcher中的时候变量还没被释放，EOCNetworkFetcher</li>
<li>可以给EOCClass对象__weak成员变量所指的内存赋值，好像可以解决问题，但是实际上completion捕获的__weak对象</li>
<li>需要通过EOCClass对象的self引用，此时已经捕获了EOCClass对象，所以还是解决不了问题。</li>
</ul>
</li>
<li>又或者EOCNetworkFetcher对象中的completion变量为__weak呢？
<ul>
<li>这样EOCClass中的completion传入进来后，超过了作用域，EOCClass中的completion就被释放</li>
<li>而EOCNetworkFetcher对象中的completion变量又没有持有接收到的completion对象，所以completion对象内存释放了</li>
<li>导致EOCNetworkFetcher对象中的completion变量永远为nil</li>
</ul>
</li>
</ul>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-07 02:21:46 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>block浅析与使用block导致循环强引用举例的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pGGbP3.html" rel="bookmark">Objective-C 内存管理浅析与循环强引用举例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				理解 变量 作用域 变量废弃 持有对象 释放对象 对象所有者(引用计数) 对象废弃 变量所有权修饰符对对象的影响 对象相互持有导致循环强引用,举例如反复执行任务的NSTimer对象的目标对象 又保留了计时器对象,若该NSTimer对象被目标对象持有,便必定会发生循环强引用,因为NSTimer对象会持有目标, 而该NSTimer对象又是目标对象的成员变量也就是目标对象又持有该NSTimer对象 此循环强引用会一直持续到目标对象调用NSTimer对象的invalidate方法释放该NSTimer对象			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmlVvD4.html" rel="bookmark">Swift-08-闭包引起的循环强引用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				循环强引用还会发生在当你将一个闭包赋值给类实例的某个实例,并且这个闭包体中又实用了这个类实例.这个闭包体重可能访问了实例的某个属性,例如self.**,或者闭包中调用了实例的某个方法,例如self.**,这两种情况都导致闭包“捕获”self,从而产生了循环强引用. 循环强引用的产生,是因为闭包和类相似,都是引用类型.当你把闭包赋值给某个属性时,你也把一个引用赋值给了这个闭包.实质上,这跟之前的问题一样,两个强引用让彼此一直有效.但是,和两个类实例不同,这次一个是类实例,另一个是闭包. Swift			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rvXPq3.html" rel="bookmark">Swift - 内存泄露原因（循环强引用）及解决办法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Swift使用自动引用计数(ARC)来管理应用程序的内存使用.在大多是情况下,并不需要考虑内存的管理.当实例不再需要的时候,ARC会自动释放这些实例所使用的内存. 但ARC并不是绝对安全的.下面两种情况会发生内存泄露. 1,类实例之间的循环强引用 两个类实例都有一个强引用指向对方,这样的情况就是强引用循环,从而导致内存泄露. 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4perVKM.html" rel="bookmark">ARC之解决闭包引起的循环强引用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				copy自:swift2.0官方教程中文版---极客学院版 1.产生闭包之间的循环强引用 直接代码和上图: class HTMLElement { let name: String let text: String? lazy var asHTML: Void -&gt; String = { if let text = self.text { return &quot;&lt;\(self.name)&gt;\(text)&lt;/\(self.name)&gt;&quot; } else { retu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoGwoBM.html" rel="bookmark">&lbrack;Swift&rsqb;Day15：闭包中的循环强引用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				闭包中的循环强引用 解决闭包和类实例之间的循环强引用可以通过定义捕获列表来实现. 捕获列表 捕获列表中的每个元素都是由weak或者unowned关键字和实例的引用(如self)成对组成.每一对都在方括号中,通过逗号分开: lazy var someClosure: (Int, String) -&gt; String = { [unowned self] (index: Int, stringToProcess: String) -&gt; String in } 我们需要判断捕获列表中的属性是弱引用还是			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Qoz8B0.html" rel="bookmark">IOS block 对象强引用和若引用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 在block外面这样:__weak MyController *weakSelf = self 或者 __weak __typeof(self) weakSelf = self; 是为了防止强引用导致循环引用 2.执行block方法体的时候也可以转换为强引用之后再使用MyController* strongSelf = weakSelf; if (!strongSelf) { return; } 那么,里面变成强引用后,不是又导致循环引用了吗?有意思的就在这里,IOS中,block内部,对			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0d28pg4.html" rel="bookmark">Block循环引用，强引用方法引起的循环引用，CenterX CenterY 不生效的问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				相信大家都用过CenterX 和 CenterY吧,这2个属性确实非常方便,但是有些时候会发现突然设置了CenterX CenterY不好使了,不居中了,一头雾水.这种情况 我建议第一时间去看看设置CenterX CenterY之前有没有设置size 也就是 宽和高.如果在设置宽高之前就设置了CenterX CenterY 肯定是不生效的,原因不用多说了吧,如果是这种情况,将先设置一下size就好了. 上一篇文章提到了block里面用了self从而导致了 循环引用,控制器释放不了,有些朋友知道应			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0YXKxJM.html" rel="bookmark">block的学习（block和timer的循环引用问题）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.什么是回调函数? 回调函数,本质上也是个函数(搁置函数和方法的争议,就当这二者是一回事).由&quot;声明&quot;.&quot;实现&quot;.&quot;调用&quot;三部分组成. 在上面的例子中,我可以看出,函数amount(其实是Block),的声明和调用在A类中,而实现部分在B类中.也就是说,B类实现了amount函数,但并没有权限调用,最终还是 由A类触发调用.我们称这样的机制为&quot;回调&quot;.意思是&quot;虽然函数的实现写在B类中,但是真正的调用还是得由A类来完			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eAwXa0.html" rel="bookmark">iOS开发Block的介绍以及Block的循环引用问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1:block的循环引用问题最主要记住两点: 如果[block内部]使用[外部声明的强引用]访问[对象A], 那么[block内部]会自动产生一个[强引用]指向[对象A] 如果[block内部]使用[外部声明的弱引用]访问[对象A], 那么[block内部]会自动产生一个[弱引用]指向[对象A] 2: #import &quot;ViewController.h&quot; #import &quot;XMGPerson.h&quot; @interface ViewController () @prop			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QWjWo0.html" rel="bookmark" class="title">Linux及文件系统基本介绍</a>
					<div>
						Linux及文件系统基本介绍 1   互联网行业现状 在服务器端市场: 超级计算机 2014年11月的数据显示前500系统中的485个系统都在运行着 Linux 的发布系统,而仅仅只有一台运行着 Wi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38Nr5gM.html" rel="bookmark" class="title">Shell脚本之：字符串</a>
					<div>
						字符串可以用单引号,也可以用双引号,也可以不用引号. 单引号 str='this is a string' 单引号字符串的限制: 1.单引号里的任何字符都会原样输出,单引号字符串中的变量是无效的: 2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mg5PBL3.html" rel="bookmark" class="title">Exata 5&period;1</a>
					<div>
						[email protected],更多内容请关注http://user.qzone.qq.com/2692407267 Exata 5.1 可以与STK 10联合仿真					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KqO1L4.html" rel="bookmark" class="title">matlab的两种函数简单使用介绍</a>
					<div>
						画图 函数方法调用 可以在此处查看所有变量的值					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qv1z54.html" rel="bookmark" class="title">iOS开发storyboard篇~~storyboard文件的读取</a>
					<div>
						一.通过代码加载storyboard文件创建控制器的view   Test.storyboard  前名是文件名,后面的storyboard是文件的扩展名 // 1. 应用程序启动完成,会调用此方法, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rvV7b3.html" rel="bookmark" class="title">iOS设计模式 - 外观</a>
					<div>
						原理图 说明 1. 当客服端需要使用一个复杂的子系统(子系统之间关系错综复杂),但又不想和他们扯上关系时,我们需要单独的写出一个类来与子系统交互,隔离客户端与子系统之间的联系,客户端只与这个单独写出来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4A6xdaM.html" rel="bookmark" class="title">Hdu 4386 Play the Dice 解题报告</a>
					<div>
						hdu 4586---Play the dice 解题思路:概率 题目描述:一个骰子有n面,每面朝上的概率相同,并且每一面上面都有一个数字,其中有m面是彩色的,代表掷到彩色面的时还可以继续掷下去,问最 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Y7ZrW4.html" rel="bookmark" class="title">使用apply的方法将伪数组转化为数组</a>
					<div>
						js中好多DOM方法都是针对数组的,可是有时候我们会取得一些伪数组,此时要想操作伪数组,那就必须把伪数组转化为数组,以下通过apply(  )的方法demo一个实例,以供大家参考(以下是部分代码):  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AZW7ZM.html" rel="bookmark" class="title">【HDOJ】3652 B-number</a>
					<div>
						终于自己写出来一道数位DP啊.继续训练DP. 1 /* 3652 */ 2 #include &lt;iostream&gt; 3 #include &lt;sstream&gt; 4 #includ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGprYQ0.html" rel="bookmark" class="title">Max Min</a>
					<div>
						1 def main(): 2 n = int(raw_input()) 3 k = int(raw_input()) 4 5 k_arr = [] 6 min_dif = 9999999999 #  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0a1QRg0.html" rel="bookmark" class="title">微信小程序设计规范</a>
					<div>
						微信小程序设计的基本原则是微信设计中心针对在微信类上线的小程序页面总结的设计指南及建议.以下设计原则都是基于对用户的尊重的基础上的,旨在微信生态类建立有号.高效.一致的用户体验的同时,最大程度顺应和支 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kojEz0.html" rel="bookmark" class="title">高防cdn未雨绸缪&comma;预防才是硬道理&excl;</a>
					<div>
						自从进入21世纪以来,互联网就在无声又深刻改变着人们的生产和生活方式,几乎成为了人们身体功能的延伸,交友.购物.娱乐等等都离不开互联网,可以说我们也已经真正进入了完全意义的网络时代.但是互联网在主导着 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGdB5a0.html" rel="bookmark" class="title">【SSH高速进阶】&mdash;&mdash;Hibernate 多对多映射</a>
					<div>
						说到多对多关系.印象最深刻的就是大学的选修课.一个学生能够选修多门课程,一门课程能够有多个学生选修,学生所选的每一门课程还有成绩. 这个场景的E-R图例如以下: 对于多对多的关系,我们一般会抽出一张中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPJajD3.html" rel="bookmark" class="title">html5 css3 active</a>
					<div>
						http://stackoverflow.com/questions/6063308/touch-css-pseudo-class-or-something-similar 替代touchstart/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02XqVn4.html" rel="bookmark" class="title">如何理解「不要用战术上的勤奋掩盖战略上的懒惰」？</a>
					<div>
						参考来源:https://www.zhihu.com/question/23453607 战略上勤快而战术上懒惰--我们说这个叫做&quot;眼高而手低&quot;.战术上勤快而战略上懒惰--我们通常 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0neXJjM.html" rel="bookmark" class="title">企业安全工作要点</a>
					<div>
						安全预警体系 安全监测体系 安全防御体系 安全评估体系 安全审计体系 规范标准流程 安全交流培训 办公网络安全 周期安全评估.模拟渗透测试(渗透/审计工具包.渗透/审计流程/步骤) 反弹后门的检测We ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgQxBL3.html" rel="bookmark" class="title">Spoj 2713 Can you answer these queries IV 水线段树</a>
					<div>
						题目链接:点击打开链接 题意: 给定n长的序列 下面2个操作 0 x y 给[x,y]区间每个数都 sqrt 1 x y 问[x, y] 区间和 #include &lt;stdio.h&gt; #i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGnXlY4.html" rel="bookmark" class="title">jquery中的&dollar;&period;post&lpar;&rpar;方法无法给变全局变量的问题</a>
					<div>
						今天遇到一个问题,在使用jquery的$.post()方法时,没有办法返回布尔值. function check_exist() { var email = $('#email').val().Tri ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wDXgl4.html" rel="bookmark" class="title">Linux常用的基本命令08</a>
					<div>
						file作用:查看文件的类型常用选项: -b 列出文件辨识结果时,不显示文件名称 -f 列出文件中文件名的文件类型(相当于把文件或目录位置写在一个文件里,批量查看,f后要紧跟文件)实例: [[emai ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDDg2oM.html" rel="bookmark" class="title">Leangoo使用看板&mdash;&mdash;创建看板&comma;更改看板名称</a>
					<div>
						1. 登录Leangoo,进入看板清单页面,点击右上角 “+” 按钮. 2. 点击新建看板,输入看板名称.看板默认为个人看板,无所属项目,您可以根据需要选择看板属于哪个项目. 更改看板名称: 点击看板 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
